#define TEXT_SERIAL
#include "SerialInterface.h"
// Datos manipulador traccion/freno y velocidad prefijada
int CalibraATOMin = 881;
int CalibraATOMax = 140;
int PinRegulador[] = {A0};
int PinATO = A1;
int PinAflojaLoco=43;
int PinAprietaLoco=44;
int PinAflojaTren=45;
int PinAprietaTren=46;
int PinInversorAD=4;
int PinInversorAT=5;

// Botonera
enum Botones
{
  LZBRebasar,
  LZBLiberar,
  LZBAlertar,
  CerrarInterruptorPrincipal,
  AbrirInterruptorPrincipal,
  SubirPantografo,
  BajarPantografo,
  FaroPrincipal,
  FaroPrincipalReducido,
  LucesPosDelanteras,
  LucesPosDelanterasCortas,
  Areneros,
  SilbatoCorto,
  SilbatoLargo,
  Sobrecarga,
  AflojeRapido,
  HombreMuerto,
  CalefaccionTren,
  Seta,
};
short PinesBotones[] = {22,23,24, 25,26,27,28, 29,30,31,32,33,34,35, 38,39, 40, 41, 42};
#define NumBotones (sizeof(PinesBotones)/sizeof(short))

// Datos lamparas
unsigned long InicioPruebaLamparas;
unsigned long FinPruebaLamparas;
int PinPruebaLamparas = 11;
enum Lamparas
{
  LuzHombreMuerto,
};
short PinesLamparas[] = {13};
#define NumLamparas (sizeof(PinesLamparas)/sizeof(short))
bool EstadoLamparas[NumBotones];
const char *NombreLamparas[] = {"lamp::hm"};

// Datos relojes
int PinAmperimetro = 10;
int PinTensionCatenaria = 9;

bool con = 0; //Conectado al servidor de datos
void serialDataHandler(const char *line, const char *value)
{
  if (!con)
  {
    for (int rep=0; rep<3; rep++)
    {
      Serial.println("register(controller::line_voltage)");
      Serial.println("register(controller::ammeter)");
      Serial.println("register(eq_res)");
      Serial.println("register(main_res)");
      Serial.println("register(brake_cylinder)");
      Serial.println("register(brake_pipe)");
      for (int i=0; i< NumLamparas; i++)
      {
        Serial.print("register(");
        Serial.print(NombreLamparas[i]);
        Serial.println(")");
      }
    }
  }
  if (!strcmp(line, "controller::line_voltage"))
  {
    analogWrite(PinTensionCatenaria, atoi(value)*0.0607);
    con = 1;
  }
  else if (!strcmp(line, "controller::ammeter"))
  {
    analogWrite(PinAmperimetro, abs(atoi(value)*0.102));
    con = 1;
  }
  else if (!strcmp(line, "eq_res"))
  {
    
  }
  else if (!strcmp(line, "main_res"))
  {
    
  }
  else if (!strcmp(line, "brake_cylinder"))
  {
    
  }
  else if (!strcmp(line, "brake_pipe"))
  {
    
  }
  else if (!strcmp(line, "connected"))
  {
    con = 1;
  }
  else for (int i=0; i<NumLamparas; i++)
  {
     if (!strcmp(line, NombreLamparas[i])) EstadoLamparas[i] = value[0] != '0';
  }
}
SerialInterface serialInterface(Serial, serialDataHandler);
void EnviarComando(const char *comando, const char *valor)
{
  Serial.print(comando);
  Serial.print('=');
  Serial.println(valor);
}
void PruebaLamparas()
{
  int i;
  if (FinPruebaLamparas > 0)
  {
    unsigned long diff = millis() - FinPruebaLamparas;
    if (diff > 1275)
    {
      FinPruebaLamparas = 0;
      i = 0;
    }
    else i = (1275 - diff)/5;
  }
  else
  {
    unsigned long diff = millis() - InicioPruebaLamparas;
    if (diff > 1275)
    {
      i = 255;
    }
    else i = diff/5;
  }
  analogWrite(PinAmperimetro, i);
  analogWrite(PinTensionCatenaria, i);
  for (int i=0; i<NumLamparas; i++)
  {
    digitalWrite(PinesLamparas[i], true);
  }
}

void setup() {
  pinMode(PinAmperimetro, OUTPUT);
  pinMode(PinTensionCatenaria, OUTPUT);
  for (int i=0; i<sizeof(PinRegulador)/sizeof(int); i++)
  {
     pinMode(PinRegulador[i], INPUT);
  }
  pinMode(PinATO, INPUT);
  pinMode(PinAflojaLoco, INPUT_PULLUP);
  pinMode(PinAprietaLoco, INPUT_PULLUP);
  pinMode(PinAflojaTren, INPUT_PULLUP);
  pinMode(PinAprietaTren, INPUT_PULLUP);
  pinMode(PinInversorAD, INPUT_PULLUP);
  pinMode(PinInversorAT, INPUT_PULLUP);
  pinMode(PinPruebaLamparas, INPUT_PULLUP);
  for (int i=0; i<NumBotones; i++)
  {
    pinMode(PinesBotones[i], INPUT_PULLUP);
  }
  for (int i=0; i<NumLamparas; i++)
  {
    pinMode(PinesLamparas[i], OUTPUT);
  }
  Serial.begin(115200);
  InicioPruebaLamparas = millis();
  while(millis() - InicioPruebaLamparas < 2300) PruebaLamparas();
  FinPruebaLamparas = millis();
  InicioPruebaLamparas = 0;
}
int regulador=0;
int ato=0;
int LeerRegulador()
{
  int pot;
  for (int i=0; i<sizeof(PinRegulador)/sizeof(int); i++)
  {
    int val = analogRead(PinRegulador[i]);
    //Serial.println(val);
    if (val > 230 && val < 610) pot = map(val, 664, 260, 0, 1000);
    else if (val > 705) pot = map(val, 679, 1011, 0, -1000);
    else pot = 0;
  }
  if (pot > 1000) pot = 1000;
  if (pot < -1000) pot = -1000;
  return pot;
  /*if (abs(pot[0]-pot[1]) > 5) return 0; // Discrepancia: manipulador inutil
  return (pot[0]+pot[1])/2;*/
}
bool EstadoBotones[NumBotones];
unsigned long LastReportedBotones;
void ActualizarBotonera()
{
  bool sendall = false;
  if (LastReportedBotones + 5000 < millis())
  {
    sendall = true;
    LastReportedBotones = millis();
  }
  for (int i=0; i<NumBotones; i++)
  {
    int state = !digitalRead(PinesBotones[i]);
    if (state != EstadoBotones[i] || sendall)
    {
      switch(i)
      {
        case HombreMuerto:
          EnviarComando("hm::pressed",state ? "0" : "1");
          break;
        case LZBAlertar:
          EnviarComando("lzb::alertar",state ? "1" : "0");
          break;
        case LZBLiberar:
          EnviarComando("lzb::liberar",state ? "1" : "0");
          break;
        case LZBRebasar:
          EnviarComando("lzb::rebasar",state ? "1" : "0");
          break;
        case CerrarInterruptorPrincipal:
          EnviarComando("controller::circuit_breaker::close",state ? "1" : "0");
          break;
        case AbrirInterruptorPrincipal:
          EnviarComando("controller::circuit_breaker::open",state ? "1" : "0");
          break;
        case BajarPantografo:
          if (state) EnviarComando("controller::pantograph", "0");
          break;
        case SubirPantografo:
          if (state) EnviarComando("controller::pantograph", "1");
          break;
        case Sobrecarga:
          EnviarComando("controller::overcharge",state ? "1" : "0");
          break;
        case AflojeRapido:
          EnviarComando("controller::quick_release",state ? "1" : "0");
          break;
        case LucesPosDelanteras:
        case FaroPrincipal:
          EnviarComando("controller::headlight", !digitalRead(PinesBotones[FaroPrincipal]) ? "2" : (!digitalRead(PinesBotones[LucesPosDelanteras]) ? "1" : "0"));
          break;
        case Areneros:
          EnviarComando("controller::sander",state ? "1" : "0");
          break;
        case SilbatoCorto:
          EnviarComando("controller::bell",state ? "1" : "0");
          break;
        case SilbatoLargo:
          EnviarComando("controller::horn",state ? "1" : "0");
          break;
        case CalefaccionTren:
          EnviarComando("controller::train_supply",state ? "1" : "0");
          break;
        case Seta:
          EnviarComando("controller::brake::emergency",state ? "0" : "1");
          break;
      }
    }
    EstadoBotones[i] = state;
  }
}
void ActualizarLamparas()
{
  if (InicioPruebaLamparas != 0) return;
  for (int i=0; i<NumLamparas; i++)
  {
    digitalWrite(PinesLamparas[i], EstadoLamparas[i]);
  }
}
int frenoTren;
int frenoLoco;
void ActualizarFreno()
{
  int f = !digitalRead(PinAprietaTren) ? 1 : (!digitalRead(PinAflojaTren) ? -1 : 0);
  if (f != frenoTren)
  {
    Serial.print("controller::brake::train=");
    Serial.println(f == 1 ? "1" : (f == -1 ? "0" : "0.5"));
    frenoTren = f;
  }
  f = !digitalRead(PinAprietaLoco) ? 1 : (!digitalRead(PinAflojaLoco) ? -1 : 0);
  if (f != frenoLoco)
  {
    Serial.print("controller::brake::engine=");
    Serial.println(f == 1 ? "1" : (f == -1 ? "0" : "0.5"));
    frenoLoco = f;
  }
}
int inversor;
void loop() {
  if (InicioPruebaLamparas != 0 || FinPruebaLamparas != 0) PruebaLamparas();
  if (!digitalRead(PinPruebaLamparas))
  {
    if (InicioPruebaLamparas == 0) InicioPruebaLamparas = millis();
    FinPruebaLamparas = millis();
  }
  else
  {
    if (InicioPruebaLamparas != 0) FinPruebaLamparas = millis();
    InicioPruebaLamparas = 0;
  }
  int pot = LeerRegulador();
  if (abs(pot-regulador) > 5 || (pot != regulador && pot == 0))
  {
    regulador = pot;
    if (regulador >= 0)
    {
      Serial.print("controller::throttle=");
      Serial.println(regulador/1000.0, 3);
      Serial.println("controller::brake::dynamic=0");
    }
    else
    {
      Serial.println("controller::throttle=0");
      Serial.print("controller::brake::dynamic=");
      Serial.println(-regulador/1000.0, 3);
    }
  }
  pot = map(analogRead(PinATO), CalibraATOMin, CalibraATOMax, 0, 1000);
  if (pot < 30) pot = 0;
  if (pot > 995) pot = 1000;
  if (abs(pot-ato) > 5 || (pot != ato && pot == 0))
  {
    ato = pot;
    Serial.print("cruise_speed=");
    Serial.println(ato * 0.2, 3);
  }
  int inv = !digitalRead(PinInversorAD) ? 1 : (!digitalRead(PinInversorAT) ? -1 : 0);
  if (inv != inversor)
  {
    inversor = inv;
    Serial.print("controller::direction=");
    Serial.println(inv);
  }
  ActualizarFreno();
  ActualizarBotonera();
  ActualizarLamparas();
  serialInterface.update();
}
